#!/bin/sh

# fifo connection test(GPOS to RTOS)
echo "Phase 1"
./com_fifo_r2m.exe 16

echo "com fifo test"
./com_fifo_r2m.exe 1 &
APP1_PID=$!
sleep 4
./com_fifo_r2m.exe 6 &
APP2_PID=$!
sleep 4
echo "KILL process (pid = $APP1_PID)"
kill $APP1_PID
sleep 4
echo "KILL process (pid = $APP2_PID)"
kill $APP2_PID
wait $APP2_PID
sleep 2

echo "Check other exit pattern"
./com_fifo_r2m.exe 1 &
APP1_PID=$!
sleep 4
./com_fifo_r2m.exe 6 &
APP2_PID=$!
sleep 4
echo "KILL process (pid = $APP2_PID)"
kill $APP2_PID
wait $APP2_PID
sleep 4
echo "KILL process (pid = $APP1_PID)"
kill $APP1_PID
wait $APP1_PID
sleep 2

# fifo connection test(RTOS to GPOS)
echo "Phase 2"
./com_fifo_m2r.exe 1 &
APP1_PID=$!
sleep 4
./com_fifo_m2r.exe 6 &
APP2_PID=$!
sleep 4
echo "KILL process (pid = $APP1_PID)"
kill $APP1_PID
wait $APP1_PID
sleep 4
echo "KILL process (pid = $APP2_PID)"
kill $APP2_PID
wait $APP2_PID
sleep 4

# fifo reconnect test
echo "Phase 3"
./com_fifo_r2m.exe 6 &
APP2_PID=$!
sleep 2
./com_fifo_reconnect.exe 1 0 & # do nothing
APP1_PID=$!
wait $APP1_PID
sleep 2
./com_fifo_reconnect.exe 1 1 & # read message
APP1_PID=$!
wait $APP1_PID
sleep 2
echo "KILL process (pid = $APP2_PID)"
kill $APP2_PID
wait $APP2_PID
sleep 2
./com_fifo_reconnect.exe 1 0 & # do nothing
APP1_PID=$!
wait $APP1_PID
sleep 2
./com_fifo_reconnect.exe 1 1 & # read message
APP1_PID=$!
wait $APP1_PID
sleep 4

# shmem test(RTOS to GPOS)
echo "Phase 4"
./com_shmem_m2r.exe 0 0 &
APP1_PID=$!
sleep 4
./com_shmem_m2r.exe 1 0 &
APP2_PID=$!
sleep 4
echo "KILL process (pid = $APP1_PID)"
kill $APP1_PID
sleep 4
echo "KILL process (pid = $APP2_PID)"
kill $APP2_PID
wait $APP2_PID
sleep 4

# shmem test(GPOS to RTOS)
echo "Phase 5"
./com_shmem_r2m.exe 0 0 &
APP1_PID=$!
sleep 4
./com_shmem_r2m.exe 1 0 &
APP2_PID=$!
sleep 4
echo "KILL process (pid = $APP1_PID)"
kill $APP1_PID
sleep 4
echo "KILL process (pid = $APP2_PID)"
kill $APP2_PID
wait $APP2_PID
sleep 4

# fifo init test
echo "Phase 6"
./com_fifo_r2m.exe 6 &
APP2_PID=$!
sleep 2
./com_fifo_init.exe 1 0 &
APP1_PID=$!
wait $APP1_PID
sleep 2
echo "KILL process (pid = $APP2_PID)"
kill $APP2_PID
wait $APP2_PID
sleep 4
./com_fifo_init.exe 1 0 &
APP1_PID=$!
wait $APP1_PID
sleep 2

./com_fifo_r2m.exe 6 &
APP2_PID=$!
sleep 4
./com_fifo_init.exe 1 1 &
APP1_PID=$!
wait $APP1_PID
sleep 4
echo "KILL process (pid = $APP2_PID)"
kill $APP2_PID
wait $APP2_PID
sleep 4
./com_fifo_init.exe 1 1 &
APP1_PID=$!
wait $APP1_PID
